package dcsp;
import java.util.Comparator; 

class AgentDataComparatorDescending implements Comparator{
    // first the overall important
    // then the variable owner
    // then the most complex
    public int compare(Object o1, Object o2)
    {
	AgentData ad1,ad2;
	ad1= (AgentData) o1;
	ad2= (AgentData) o2;
	int res;
	boolean before1, before2;
	res=sgn(ad1.importance-ad2.importance);
	if (res!=0)
	    return res;
	before1=isBefore(ad1,ad2);
	before2=isBefore(ad2,ad1);
	if(before1^before2)
	    if(before1)
		return 1;
	    else
		return -1;
	res=sgn(ad1.complexity-ad2.complexity);
	return res;
    }
    boolean isBefore(AgentData ad1, AgentData ad2)
    {
	SVariable[] av1, av2;
	av1=ad1.getSVariables();
	av2=ad2.getSVariables();
	int l1;
	l1=av1.length;
	for(int k1=0;k1<l1;k1++)
	    if(av1[k1].isOwner())
		if(contains(av2,av1[k1]))
		    return true;
	return false; 
    }
    // check if sv is contained in av without being owner there
    boolean contains(SVariable[] av, SVariable sv)
    {
	int l;
	l=av.length;
	for(int k=0;k<l;k++)
	    if(av[k].getSVariable().equals(sv.getSVariable()))
		if(!av[k].isOwner())
		    return true;
	return false;
    }
    int sgn(int nr)
    {
	return (nr==0)?0:(nr<0)?-1:1;
    }
}
