package dcsp;
import dcsp.parameters.*;
import java.util.*;

public class DAccepted implements DObject {
    public String senderName="Unknown";
    // variable mapped to DVarHistory
    public Hashtable history;
    public IAgentServer agent;
    public DCost cost;
    public boolean vide(){
	if(history==null){
	    //System.out.println("Empty history in accepted");
	    return true;
	}
	if(history.size()<=0){
	    //System.out.println("Empty history in accepted");
	    return true;
	}
	return false;
    }
    public boolean empty(){
	boolean result=true;
	if(history==null){
	    //System.out.println("Empty history in accepted");
	    return true;
	}
	Iterator it=(Iterator)history.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    Range range=(Range)history.get(var);
	    int size=range.size();
	    if(size<=0){
		//System.out.println("empty domain:"+var+"="+range+" size="+size);
		return true;
	    }
	    //System.out.println("non empty domain found:"+var+"="+range);
	    result=false;
	}
	return result;
    }
    public String toString(){
	String s;
	s=senderName+":Accepted Solution:\n";
	if(history==null) return s+"null\n";
	Iterator it=(Iterator)history.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    s=s+var+(history.get(var)).toString()+"\n";
	}
	if(cost!=null)
	    s=s+cost.toString();
	return s+"\n";
    }
}
