package dcsp;

class OneWayThread extends Thread {
    IAgentServer agent;
    String command;
    Object parameters;
    Object sID;
    boolean removable=false;
    OneWayThread(IAgentServer _agent){
	agent=_agent;
    }
    public void setMessage(String _command, Object _parameters, Object _sID){
	command=_command;
	parameters=_parameters;
	sID=_sID;
    }
    public void run(){
	System.out.println("oneway "+command);
	try {
	    agent.message(command, parameters, sID);
	}catch (Exception e){
	    System.err.println("OneWay Error");
	    e.printStackTrace();
	}
	if(removable)
	    ((AgentServer)agent).removeThread(this);
    }
}
