package dcsp;
    
class Semaphore {
    int perm=0;
    synchronized void inc(){
	perm=1;
    }
    
    synchronized boolean requestWait(){
	while (perm<=0){
	    try {
		this.wait();
	    }catch (Exception e){
		System.err.println("interrupted");
		e.printStackTrace();
		perm=0;
		    return false;
	    }
	    }
	perm--;
	return true;
    }
    synchronized boolean request(){
	if (perm>0){
		perm--;
		return true;
	}
	return false;
    }
}
