package dcsp;
import java.util.*;
import java.io.*;

class SetOfConstraints {
    Hashtable cons = new Hashtable();
    Problem problem;
    SetOfConstraints(Problem _problem){
	problem=_problem;
    }
    public Problem getProblem(){
	return problem;
    }
    public int getConstraintsNr(){
	return cons.size();
    }
    public Constraint[] getConstraints(){
	return (Constraint[])cons.values().toArray(new Constraint[0]);
    }
    public int getComplexity(){
	return getConstraintsNr();
    }
    public boolean colorLoader(RandomAccessFile fis,int varNr,String key,int fileType){
	Constraint c= new Constraint(this,varNr);
	System.out.println(key);
	c.loadFile(fis,varNr,fileType);
	if(cons.put(key,c)!=null)
	    System.out.println("Constraint replaced");
	return true;
    }
}
