package dcsp;
import java.rmi.*;
import java.io.*;

class AgentApp {
    public static void main(String args[]){
	String title;
	String url="none",problem="";
	System.out.println("Welcome to LIA Agency!");
	title = "Agent of the LIA Search Machine";
	if (args.length>0)
	    title = args[0];
	System.out.println("Launching Agent: " +title+ " ...");
	if (args.length>1){
	    url = args[1];
	    System.out.println("Looking for broker: "+ url);
	}
	if (System.getSecurityManager() == null)
	    System.setSecurityManager(new RMISecurityManager());
	Agent agent = new Agent(title, url);
	System.out.println("Agent: " + title + " Setup OK");
	if (args.length>2){
	    problem = args[2];
	    System.out.println("Loading problem: "+problem);
	    if(agent.loadFile(new File(problem)))
		agent.run();
	    else
		System.err.println("Error loading file:"+problem);
	}
	System.out.println("Good Bye!");	
    }
    public void finalize(){
	System.out.println("agent dying!");
    }
}
