package dcsp;
import dcsp.parameters.DObject;

class AgentData implements DObject{
    IAgentServer agent;
    String name;
    SVariable[] svars;
    int importance,complexity;
    AgentData(){}
    public String toString(){
	String s="";
	if(name!=null)
	    s=s+" Nume:"+name+":variables::";
	if(svars!=null)
	    for(int k=0;k<svars.length;k++){
		if(svars[k]!=null)
		    s=s+svars[k]+":";
	    }
	return s;
    }
    public boolean set(IAgentServer _agent, SVariable _svars[], int _importance, int _complexity){
	agent=_agent;
	svars=_svars;
	importance=_importance;
	complexity=_complexity;
	try {
	    name=(String)BrokerServer.messageSend(agent,"GETNAME",null);
	}catch (Exception e){
	    System.err.println("AgentDate:set:Error reaching the calling agent:"+agent);
	    System.err.println(e);
	    e.printStackTrace();
	    return false;
	}
	return true;
    }
    public int getComplexity(){
	return complexity;
    }
    public int getImportance(){
	return importance;
    }
    public SVariable[] getSVariables(){
	return svars;
    }
    public IAgentServer getAgent(){
	return agent;
    }
    public String getName(){
	return name;
    }
}
