package dcsp;
import java.util.Comparator; 

class AgentDataComparator implements Comparator{
    // first the overall important
    // then the variable owner
    // then the most complex
    public int compare(Object o1, Object o2){
	AgentData ad1,ad2;
	ad1= (AgentData) o1;
	ad2= (AgentData) o2;
	System.out.print("comparing:"+ad1.name+" with "+ad2.name+":");
	int res;
	boolean before1, before2;
	res=sgn(ad2.importance-ad1.importance);
	if (res!=0){
	    System.out.println(":IMPORTANCE:"+res);
	    return res;
	}
	before1=isBefore(ad1,ad2);
	before2=isBefore(ad2,ad1);
	if(before1&&before2)
	    System.out.print(":AND:");
	if(before1||before2)
	    System.out.print(":OR:");
	if(before1^before2)
	    if(before1){
		System.out.println(":XOR:"+(-1));
		return -1;
	    }else{
		System.out.println(":XOR:"+1);
		return 1;
	    }
	res=sgn(ad2.complexity-ad1.complexity);
	System.out.println(":COMPLEXITY:"+res);
	return res;
    }
    static boolean isBefore(AgentData ad1, AgentData ad2){
	SVariable[] av1, av2;
	av1=ad1.getSVariables();
	av2=ad2.getSVariables();
	int l1;
	l1=av1.length;
	for(int k1=0;k1<l1;k1++)
	    if(av1[k1].isOwner())
		//checks no owner there
		if(contains(av2,av1[k1]))
		    return true;
	return false; 
    }
    // check if sv is contained in av without being owner there
    static boolean contains(SVariable[] av, SVariable sv){
	int l;
	l=av.length;
	for(int k=0;k<l;k++)
	    if(av[k].getSVariable().equals(sv.getSVariable()))
		if(!av[k].isOwner())
		    return true;
	return false;
    }
    static int sgn(int nr){
	return (nr==0)?0:(nr<0)?-1:1;
    }
}
