package dcsp;
import java.io.*;

class C1Representation extends CRepresentation {
    int tab[];
    SetOfVariables vset;
    int dim[]=new int[1];
    String vars[]=new String[1];

    C1Representation(Constraint _owner){
	super(_owner);
	vset=getConstraint().getSetOfConstraints().getProblem().getSetOfVariables();
    }
    public int[] getDim(){
	return dim;
    }
    int[] getMatrix(){
	return tab;
    }
    Constraint getConstraint(){
	return owner;
    }
    public int getVariablesNr(){
	System.out.println("Constraint unidirectional");
	return 1;
    }
    public String getVariable(int index){
	return vars[index];
    }
    int getID(int index){
	return owner.getID(index);
    }   
    public boolean loadFile(RandomAccessFile fis, int fileType){
	vars[0]=vset.loader(fis, fileType);
	dim[0]=vset.getSize(vars[0]);
	tab=new int[dim[0]];
	int x,y;
	for(x=0;x<dim[0];x++){
	    tab[x]=Utils.getInt(fis);
	    System.out.print(tab[x]+"\t");
	}
	System.out.println("");
	return true;
    }
}
