package dcsp;
import java.io.*;

class C2Representation extends CRepresentation {
    int tab[][];
    SetOfVariables vset;
    int dim[]=new int[2];
    String vars[]=new String[2];

    C2Representation(Constraint _owner){
	super(_owner);
	vset=getConstraint().getSetOfConstraints().getProblem().getSetOfVariables();
    }
    public int[] getDim(){
	return dim;
    }
    int[][] getMatrix(){
	return tab;
    }
    Constraint getConstraint(){
	return owner;
    }
    public int getVariablesNr(){
	return 2;
    }
    public String getVariable(int index){
	return vars[index];
    }
    public int getID(int index){
	return owner.getID(index);
    }   
    public boolean loadFile(RandomAccessFile fis, int fileType){
	vars[0]=vset.loader(fis, fileType);
	vars[1]=vset.loader(fis, fileType);
	dim[0]=vset.getSize(vars[0]);
	dim[1]=vset.getSize(vars[1]);
	tab=new int[dim[0]][dim[1]];
	int x,y;
	for(x=0;x<dim[0];x++){
	    for(y=0;y<dim[1];y++){
		tab[x][y]=Utils.getInt(fis);
		System.out.print(tab[x][y]+"\t");
	    }
	    System.out.println("");
	}
	return true;
    }
}
