package dcsp;
import java.io.*;

class Constraint {
    CRepresentation mat;
    SetOfConstraints owner;
    int[] varIDs=new int[2];
    Constraint(SetOfConstraints _owner){
	owner=_owner;
    }
    Constraint(SetOfConstraints _owner, int varNr){
	owner=_owner;
    }
    public int getVariablesNr(){
	return mat.getVariablesNr();
    }
    public String getVariable(int index){
	return mat.getVariable(index);
    }
    public void setID(int index,int id){
	varIDs[index]=id;
    }
    public int getID(int index){
	return varIDs[index];
    }   
    public CRepresentation getRepresentation(){
	return mat;
    }
    public SetOfConstraints getSetOfConstraints(){ 
	return owner;
    }
    public boolean loadFile(RandomAccessFile fis, int varNr, int fileType){
	switch(varNr){
	case 1:
	    mat=new C1Representation(this);
	    mat.loadFile(fis,fileType);
	    break;
	case 2: 
	    mat=new C2Representation(this);
	    mat.loadFile(fis,fileType);
	    break;
	default:
	    return false;
	}
	return true;
    }
}
