package dcsp;
import dcsp.parameters.*;

public class DSubscription implements DObject {
    public IAgentServer agent;
    public String name;
    public SVariable variables[];
    public int importance;
    public int complexity;
    public String[] protocols;
    
    DSubscription(IAgentServer _agent, SVariable _variables[], int _importance, int _complexity, String[] _protocols, String _name){
	agent=_agent;
	name=_name;
	variables=_variables;
	importance=_importance;
	complexity=_complexity;
	protocols=_protocols;
    }
    public String toString(){
	int k;
	String s=" name: "+name+"\n";
	s=s+" complexity: "+complexity+"\n";
	s=s+" importance: "+importance+"\n";
	if(variables!=null)
	    for(k=0;k<variables.length;k++){
		s=s+" variable: "+variables[k].getSVariable();
		s=s+" owner: "+(variables[k].isOwner()?1:-1)+"\n";
	    }
	if(protocols!=null)
	    for(k=0;k<protocols.length;k++){
		s=s+" protocol: "+protocols[k]+"\n";
	    }	
	return s;
    }
}
