package dcsp;
import java.util.*;
import dcsp.parameters.*;

class WorldView {
    Hashtable knowledge=new Hashtable();
    WorldView() {}
    public void add(String symbol, Range range)
    {
		knowledge.put(symbol,range);
    }
    public void add(Domain[] domains)
    {
	for(int k=0;k<domains.length;k++)
	    {
		knowledge.put(domains[k].symbol(),domains[k].range());
	    }
    }
    public Hashtable getKnowledge()
    {
	return knowledge;
    }
    public Range get(String variable)
    {
	return (Range)knowledge.get(variable);
    }
}
